#include <windows.h>
#include "ImcSongApi.h"

#define SONGNAME "Unnamed song"
#define SP "                                                                  "

TImcSongPos songPos;

HWND mainWindow;

HDC memDc;
HBITMAP memBitmap;

void InitEffect() {
  HDC dc = GetDC(mainWindow);
  memDc = CreateCompatibleDC(dc);
  memBitmap = CreateCompatibleBitmap(dc,512,100);
  SelectObject(memDc,memBitmap);
  ReleaseDC(mainWindow, dc);
}

void DrawEffect() {
  static unsigned int screen[512*100];
  int p=0;
  for(int y=0;y<100;y++) {
    for(int x=0;x<512;x++,p++) {
      int c1 = ImcIntSin(x+songPos.curTime/16+y*2) + ImcIntSin(y+songPos.curTime/32);
      int c2 = ImcIntSin(x*2+y-songPos.curTime/16) + ImcIntSin(y*2+x+songPos.curTime/64);
      int c3 = ImcIntSin(x+ImcIntSin(x+y-songPos.curTime/32)) + ImcIntSin(y+ImcIntSin(x-y*2+songPos.curTime/32));
      c1 = (c1+512)/2;
      c2 = (c2+512)/2;
      c3 = (c3+512)/2;
      if(((x+y/8)&7)==0 || ((y-x/8)&7)==0) {
        c1 = (c1 * 20 / 22);
        c2 = (c2 * 20 / 22);
        c3 = (c3 * 20 / 22);
      }
      if(c1<0) c1=0;
      if(c2<0) c2=0;
      if(c3<0) c3=0;
      if(c1>255) c1=255;
      if(c2>255) c2=255;
      if(c3>255) c3=255;
      screen[p] = (c1<<16) | (c2<<8) | c3;
    }
  }
  SetBitmapBits(memBitmap,512*100*4,screen);
}

LRESULT CALLBACK WindowProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp) {
  switch(msg) {
    case WM_DESTROY:
      ExitProcess(0);
      return 0;
    case WM_KEYDOWN:
      if(wp==VK_ESCAPE)
        ExitProcess(0);
      return 0;
    case WM_PAINT:
      DrawEffect();
      HDC dc;
      PAINTSTRUCT ps;
      dc = BeginPaint(hwnd,&ps);
      BitBlt(dc, 0, 0, 512, 100, memDc, 0, 0, SRCCOPY);
      SetBkMode(dc,TRANSPARENT);
      TextOut(dc,8,8,SONGNAME SP,32);
      TextOut(dc,54,50,"IMC Player v3.3 by PuavoHard",28);
      MoveToEx(dc,26,32,NULL);
      LineTo(dc,26,42);
      MoveToEx(dc,26+256,32,NULL);
      LineTo(dc,26+256,42);
      MoveToEx(dc,26,32,NULL);
      LineTo(dc,26+256,32);
      MoveToEx(dc,26,42,NULL);
      LineTo(dc,26+256,42);
      int p = ((songPos.curOrderPos<<8)+(songPos.curRowInPattern<<4)) / IMCSONG_LEN;
      MoveToEx(dc,26,36,NULL);
      LineTo(dc,26+p,36);
      MoveToEx(dc,26,37,NULL);
      LineTo(dc,26+p,37);
      MoveToEx(dc,26,38,NULL);
      LineTo(dc,26+p,38);
      EndPaint(hwnd,&ps);
      return 0;
  }
  return DefWindowProc(hwnd, msg, wp, lp);
}

WNDCLASS wc = {
  0,
  WindowProc,
  0,
  0,
  NULL,
  NULL,
  NULL,
  (HBRUSH)(COLOR_WINDOW+1),
  NULL,
  "IMC Player Window"
};

int WINAPI WinMain(HINSTANCE hinst, HINSTANCE prevHinst, LPSTR cmdLinst, int showCmd) {

  wc.hInstance = hinst;
  wc.hCursor = LoadCursor(NULL,IDC_ARROW);
  RegisterClass(&wc);

  mainWindow = CreateWindow(
    "IMC Player Window",
    SONGNAME,
    WS_OVERLAPPED|WS_SYSMENU|WS_MINIMIZEBOX,
    CW_USEDEFAULT,
    CW_USEDEFAULT,
    320,100,
    NULL,
    NULL,
    hinst,
    NULL
  );

  InitEffect();

  ShowWindow(mainWindow, showCmd);
  UpdateWindow(mainWindow);

  Sleep(300);

  ImcSongPlay();

  MSG msg;
  while(true) {
    if(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)) {
      DispatchMessage(&msg);
      continue;
    }
    Sleep(20);
    ImcSongUpdatePos(songPos);
    if(songPos.curOrderPos>=IMCSONG_LEN)
      ExitProcess(0);
    InvalidateRect(mainWindow,NULL,false);
  }

}

void WinMainCRTStartup() {
  WinMain(GetModuleHandle(NULL),NULL,NULL,SW_SHOW);
}

